# Class: Layer

## ol.layer.Layer

Abstract base class. A visual representation of raster or vector map data. Layers group together those properties that pertain to how the data is to be displayed, irrespective of the source of that data.

#### new ol.layer.Layer(options) experimental

src/ol/layer/layer.js, line 25

  Name | Type | Description
  --- | --- | ---
  `options` | Layer options.
  Name | Type | Description
  --- | --- | ---
  `brightness` | number | undefined | optional Brightness. Default is `0`.
  `contrast` | number | undefined | optional Contrast. Default is `1`.
  `hue` | number | undefined | optional Hue. Default is `0`.
  `opacity` | number | undefined | optional Opacity (0, 1). Default is `1`.
  `saturation` | number | undefined | optional Saturation. Default is `1`.
  `source` | ol.source.Source | Source for this layer.
  `visible` | boolean | undefined | optional Visibility. Default is `true` (visible).
  `minResolution` | number | undefined | optional The minimum resolution (inclusive) at which this layer will be visible.
  `maxResolution` | number | undefined | optional The maximum resolution (exclusive) below which this layer will be visible.

  ##### Fires:

  - `beforepropertychange` (ol.ObjectEvent) experimental - Triggered before a property is changed.
  - `change` experimental - Triggered when the state of the source changes.
  - `change:brightness` (ol.ObjectEvent) experimental
  - `change:contrast` (ol.ObjectEvent) experimental
  - `change:hue` (ol.ObjectEvent) experimental
  - `change:maxresolution` (ol.ObjectEvent) experimental
  - `change:minresolution` (ol.ObjectEvent) experimental
  - `change:opacity` (ol.ObjectEvent) experimental
  - `change:saturation` (ol.ObjectEvent) experimental
  - `change:visible` (ol.ObjectEvent) experimental
  - `postcompose` (ol.render.Event) experimental
  - `precompose` (ol.render.Event) experimental
  - `propertychange` (ol.ObjectEvent) experimental - Triggered when a property is changed.
  - `render` (ol.render.Event) experimental

### Subclasses

- ol.layer.Image
- ol.layer.Tile
- ol.layer.Vector

### Extends

- ol.layer.Base

### Observable Properties

Name | Type | Settable | ol.ObjectEvent type | Description
--- | --- | --- | --- | ---
`brightness` | number | undefined | yes | `change:brightness` | The brightness of the layer.
`contrast` | number | undefined | yes | `change:contrast` | The contrast of the layer.
`hue` | number | undefined | yes | `change:hue` | The hue of the layer.
`maxResolution` | number | undefined | yes | `change:maxresolution` | The maximum resolution of the layer.
`minResolution` | number | undefined | yes | `change:minresolution` | The minimum resolution of the layer.
`opacity` | number | undefined | yes | `change:opacity` | The opacity of the layer.
`saturation` | number | undefined | yes | `change:saturation` | The saturation of the layer.
`visible` | boolean | undefined | yes | `change:visible` | The visiblity of the layer.

### Methods

#### bindTo(key, target, opt_targetKey){ol.ObjectAccessor} inherited experimental

src/ol/object.js, line 257

  The bindTo method allows you to set up a two-way binding between a `source` and `target` object. The method returns an ol.ObjectAccessor with a transform method that lets you transform values on the way from the source to the target and on the way back.

  For example, if you had two map views (sourceView and targetView) and you wanted the target view to have double the resolution of the source view, you could transform the resolution on the way to and from the target with the following:

      sourceView.bindTo('resolution', targetView)
        .transform(
          function(sourceResolution) {
            // from sourceView.resolution to targetView.resolution
            return 2 * sourceResolution;
          },
          function(targetResolution) {
            // from targetView.resolution to sourceView.resolution
            return targetResolution / 2;
          }
        );

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `target` | ol.Object | Target.
  `targetKey` | string | optional Target key.

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### get(key){*} inherited experimental

src/ol/object.js, line 314

  Gets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

  ##### Returns:

  Value.

#### getBrightness(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 86

  ##### Returns:

  The brightness of the layer.

#### getContrast(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 101

  ##### Returns:

  The contrast of the layer.

#### getHue(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 116

  ##### Returns:

  The hue of the layer.

#### getKeys(){Array.<string>} inherited experimental

src/ol/object.js, line 342

  Get a list of object property names.

  ##### Returns:

  List of property names.

#### getMaxResolution(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 174

  ##### Returns:

  The maximum resolution of the layer.

#### getMinResolution(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 189

  ##### Returns:

  The minimum resolution of the layer.

#### getOpacity(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 204

  ##### Returns:

  The opacity of the layer.

#### getProperties(){Object.<string, *>} inherited experimental

src/ol/object.js, line 374

  Get an object of all property names and values.

  ##### Returns:

  Object.

#### getSaturation(){number|undefined} inherited experimental

src/ol/layer/layerbase.js, line 219

  ##### Returns:

  The saturation of the layer.

#### getSource(){ol.source.Source} experimental

src/ol/layer/layer.js, line 83

  ##### Returns:

  Source.

#### getVisible(){boolean|undefined} inherited experimental

src/ol/layer/layerbase.js, line 240

  ##### Returns:

  The visiblity of the layer.

#### notify(key) inherited experimental

src/ol/object.js, line 394

  Notify all observers of a change on this property. This notifies both objects that are bound to the object's property as well as the object that it is bound to.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### set(key, value) inherited experimental

src/ol/object.js, line 425

  Sets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `value` | * | Value.

#### setBrightness(brightness) inherited experimental

src/ol/layer/layerbase.js, line 272

  Adjust the layer brightness. A value of -1 will render the layer completely black. A value of 0 will leave the brightness unchanged. A value of 1 will render the layer completely white. Other values are linear multipliers on the effect (values are clamped between -1 and 1).

  The filter effects draft [1] says the brightness function is supposed to render 0 black, 1 unchanged, and all other values as a linear multiplier.

  The current WebKit implementation clamps values between -1 (black) and 1 (white) [2]. There is a bug open to change the filter effect spec [3].

  TODO: revisit this if the spec is still unmodified before we release

  [1] https://dvcs.w3.org/hg/FXTF/raw-file/tip/filters/index.html [2] https://github.com/WebKit/webkit/commit/8f4765e569 [3] https://www.w3.org/Bugs/Public/show_bug.cgi?id=15647

  Name | Type | Description
  --- | --- | ---
  `brightness` | number | undefined | optional The brightness of the layer.

#### setContrast(contrast) inherited experimental

src/ol/layer/layerbase.js, line 290

  Adjust the layer contrast. A value of 0 will render the layer completely grey. A value of 1 will leave the contrast unchanged. Other values are linear multipliers on the effect (and values over 1 are permitted).

  Name | Type | Description
  --- | --- | ---
  `contrast` | number | undefined | optional The contrast of the layer.

#### setHue(hue) inherited experimental

src/ol/layer/layerbase.js, line 306

  Apply a hue-rotation to the layer. A value of 0 will leave the hue unchanged. Other values are radians around the color circle.

  Name | Type | Description
  --- | --- | ---
  `hue` | number | undefined | optional The hue of the layer.

#### setMaxResolution(maxResolution) inherited experimental

src/ol/layer/layerbase.js, line 320

  Name | Type | Description
  --- | --- | ---
  `maxResolution` | number | undefined | optional The maximum resolution of the layer.

#### setMinResolution(minResolution) inherited experimental

src/ol/layer/layerbase.js, line 334

  Name | Type | Description
  --- | --- | ---
  `minResolution` | number | undefined | optional The minimum resolution of the layer.

#### setOpacity(opacity) inherited experimental

src/ol/layer/layerbase.js, line 348

  Name | Type | Description
  --- | --- | ---
  `opacity` | number | undefined | optional The opacity of the layer.

#### setSaturation(saturation) inherited experimental

src/ol/layer/layerbase.js, line 367

  Adjust layer saturation. A value of 0 will render the layer completely unsaturated. A value of 1 will leave the saturation unchanged. Other values are linear multipliers of the effect (and values over 1 are permitted).

  Name | Type | Description
  --- | --- | ---
  `saturation` | number | undefined | optional The saturation of the layer.

#### setValues(values) inherited experimental

src/ol/object.js, line 454

  Sets a collection of key-value pairs.

  Name | Type | Description
  --- | --- | ---
  `values` | Object.<string, *> | Values.

#### setVisible(visible) inherited experimental

src/ol/layer/layerbase.js, line 381

  Name | Type | Description
  --- | --- | ---
  `visible` | boolean | undefined | optional The visiblity of the layer.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unbind(key) inherited experimental

src/ol/object.js, line 468

  Removes a binding. Unbinding will set the unbound property to the current value. The object will not be notified, as the value has not changed.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### unbindAll() inherited experimental

src/ol/object.js, line 492

  Removes all bindings.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.